model compact
.386c
.code
jumps
locals @@

;WID = 74
WID = 500 ; large enough so that tasm won't make byte imuls

public _ReconfigureVideoWidth
_ReconfigureVideoWidth:
	mov word ptr [cs:@WID1], ax
	shl ax,1
	mov word ptr [cs:@WIDTWO1], ax
	mov word ptr [cs:@WIDTWO2], ax
	mov word ptr [cs:@WIDTWO3], ax
	shr ax,2
	mov word ptr [cs:@WIDHALF1], ax
	mov word ptr [cs:@WIDHALF2], ax
	ret

public _VidMemBytePos
_VidMemBytePos:
        xchg ax, dx
        ;lea ax, [eax+eax*4]   ; This requires compilation through tasm
        ;shl ax, 4
        imul ax, ax, WID
@WID1 equ $-2
        
        add ax, dx
        add ax, ax
        ret
	
public _mygotoxy
_mygotoxy:
        mov bh, al  ; page
        mov dh, bl  ; y
        mov ah, 2
        ;mov dl, x   -- already there
        int 10h
        ret

public _mymovetext
_mymovetext:
	; vidmem_begin_offs  (AX)
	; y1                 (DX)
	; y2                 (BX)
	; toy                ([SP])

	; n_words <= (148/4) * (y2-y1+1)
	; di <= offs + 148 * toy(di)
	; si <= offs + 148 * y1 (dx)

	movzx ecx, bx
	sub cx, dx

	push si
	push di
	
	;lea cx, [ecx + ecx*4 + 5]
	
	shr ax, 4      ; this assumes page offsets are divisible with 16
	add ax, 0B800h
	;shl cx, 3                ; cx = 40 * (y2-y1+1)
	
	inc cx
	imul cx, cx, WID/2 ; cx = (y2-y1+1)*WID/2
@WIDHALF1 equ $-2
	
	;movzx edi, word[esp+4]
	mov di, word[esp+4]

	;lea di, [edi + edi*4]
	;shl di, 5
	imul di, di, WID*2
@WIDTWO1 equ $-2

	;lea si, [edx + edx*4]
	;shl si, 5
	imul si, si, WID*2
@WIDTWO2 equ $-2

	push ds
	 mov ds, ax
	 mov es, ax
	 cmp di, si
	 ja short @@backwards
	 cld
	 rep movsd
	 jmp short @@done
@@backwards:
	 lea si, [esi+ecx*4-4]
	 lea di, [edi+ecx*4-4]
	 std
	 rep movsd
	 cld
@@done:
	pop ds
	pop di
	pop si
	ret 2



public _mygettext
_mygettext:
	; AX = offs
	; DX = size (NUMBER OF WORDS)
	; [SP+4] = data
	push bp
	mov bp,sp
	push si
	push di
	push ds
	 mov si, ax
	 les di, [bp+4]
	 mov ax, 0B800h
	 mov ds, ax
	 jmp wordcopycommon


public _myputtext
_myputtext:
	; AX = offs
	; DX = size (NUMBER OF WORDS)
	; [SP+4] = data
	push bp
	mov bp, sp
	push si
	push di
	push ds
	 mov di, ax
	 lds si, [bp+4]
	 mov ax, 0B800h
	 mov es, ax
wordcopycommon:
	 cld
	 mov cx, dx
	 or cx, cx
	 jz @@butnone
	 dec cx
	 shr cx, 1
	 jnc @@buttwo
	 movsw
@@buttwo:
	 jz @@butnone
	 rep movsd
@@butnone:
	pop ds
	pop di
	pop si
	pop bp
	ret 4


public _myfilltext
_myfilltext:
	; AX = pagebegin+pos
	; DX = size (NUMBER OF WORDS)
	; BX = model
	push di
	 mov di, ax
	 mov ax, 0B800h
	 mov es, ax
	 mov cx, dx
	 or cx, cx
	 jz @@butnone
	 movzx eax, bx
	 cld
	 shr cx, 1
	 jnc @@buttwo
	 stosw
@@buttwo:
	 jz @@butnone
	 shl eax, 16
	 mov ax, bx
	 rep stosd
@@butnone:
	pop di
	ret

public _myfilltext_lines
_myfilltext_lines:
	; AX = pagebegin  --> ES = B800h + ax/16
	; DX = y          --> DI = dx*WID*2
	; BX = size (rows). bytes = bx*WID*2, dwords=bx*74*2/4=bx*WID/2
	; [SP+2] = model
	push di
	 shr ax, 4
	 imul di, dx, WID*2
@WIDTWO3 equ $-2
	 ;lea di, [edx + edx*4]
	 add ax, 0B800h
	 ;shl di, 5
	 mov es, ax
	 ;lea cx, [ebx + ebx*4]
	 imul cx, bx, WID/2
@WIDHALF2 equ $-2
	 mov bx, word[esp+2]
	 mov ax, bx
	 shl eax, 16
	 mov ax, bx
	 ;shl cx, 3
	 cld
	 rep stosd
	pop di
	ret 2

public _mymovevidwords
_mymovevidwords:
	; AX = source offs
	; DX = target offs
	; BX = number of words to move
	push si
	push di
	 mov si, ax
	 mov di, dx
	 mov cx, bx
	 or cx, cx
	 jz @@no_words
	 inc cx
	 cld
	 cmp di, si
	 jb @@do_copy ; target before source
@@source_before_target:
	 ; copy backwards
	 std
	 mov ax, cx
	 sub ax, 2
	 shl ax, 1
	 add si, ax
	 add di, ax
@@do_copy:
	 push ds
	  mov ax, 0B800h
	  mov es, ax
	  mov ds, ax
	  shr cx, 1
	  jnc @@buttwo
	  movsw
@@buttwo:
	  jz @@butnone
	  rep movsd
@@butnone:
	 pop ds
@@no_words:
	pop di
	pop si
	ret

.data
SavedFont db 256*32 dup (?)
.code

public _MakeFontMemAvail
public _MakeFontMemUnavail
_MakeFontMemAvail:
	mov si, offset @@172
	jmp FontManip
@@172:
	db 2,4 ; enable plane 2
	db 6,0
_MakeFontMemUnavail:
	mov si, offset @@17C
	jmp FontManip
@@17C:
	db 2,3 ; enable planes 0,1
	db 6,0Eh

FontManip:
	cli
	 call @@23
	sti
	ret
@@23:
	;mov cx,2
	mov dx,3C4h
	call @@24
	;mov cx,3
	mov dl,0CEh
@@24:	db 2Eh
	lodsb
	out dx, al
	inc dx
	db 2Eh
	lodsb
	out dx, al
	dec dx
	;loop @@24
	ret

END
